!!
!!  Xet - X Entertainment (a tool to create animated images)
!!
!!
!!  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
!!
!!
!!  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
!!
!! Permission to use, copy, and distribute for non-commercial purposes,
!! is hereby granted without fee, providing that the above copyright
!! notice appear in all copies and that both the copyright notice and this
!! permission notice appear in supporting documentation. 
!!
!! This software is provided as-is and without any warranty of any kind.


#include "motif.macros"
 
XET.wcChildren:	     main
XET.wcPopups:        areYouSureTBL,infoModalTBL,exitDialog
XET.wcCallback:	     WcSetValue(this.title: Coalition Software (Xet) )
XET*WcTrace:         False
*background:	     XET_SKYBLUE4
*foreground:         XET_WHITE

*fontList:	     -adobe-new century schoolbook-medium-r-normal--10-*

!!######################################################
!!     mainWidow
!!######################################################
*main.wcCreate:		         XmCreateMainWindow
*main.wcChildren:		 menuBar, workAreaTBL 
*main.afterChildren:	         WcSetValue( this.menuBar: this.menuBar) \
			         WcSetValue( this.workWindow: this.workAreaTBL)

*main.mainWindowMarginWidth:     0
*main.showSeparator:             FALSE
*main.spacing:                   4
!!*main.width:                     740
!!*main.height:                    720
 

!#################################################################
! Minimal menu bar
!#################################################################

*menuBar.WcCreate:		  XmCreateMenuBar
*menuBar.WcPopups:                \
                                  fileMenu,buildMenu,playMenu,colorMenu, \
				  miscMenu,helpMenu
*menuBar.WcChildren:		  File,Build,Play,Color, Misc,  Help

*menuBar.wcAfterChildren:	  WcSetValue( this.menuHelpWidget: this.Help )
*menuBar*fontList:		  -*-new century schoolbook-bold-r-*-*-18-180-*
*menuBar.background:              XET_GRAY80
*menuBar.spacing:		  10
*menuBar.highlightThickness:      4
*menuBar.bottomShadowColor:       XET_BLACK
*menuBar.topShadowColor:          XET_GRAY50
*menuBar.shadowThickness:         5


!! without this line casecadebuttons won't come out, don't know why
*menuBar*WcCreate:		  XmCascadeButton


!----------------------------file menu pulldown-----------------------------
*menuBar.fileMenu.wcCreate:	  XmCreatePulldownMenu
*fileMenu.wcChildren:		  loadFile,     \
                                  saveFileAs,   \
                                  sep1,         \
                                  sep1,         \
				  config,       \
	      			  reinitialize, \
                                  recapture,    \
                                  sep1,         \
				  sep1,         \
                                  cleaninfotxt, \
                                  dumpinfotxt,  \
                                  sep1,         \
				  sep1,         \
                                  quit

MakeButton(*loadFile,Load  Xet  Script,WcCreateRootCB(LoadFSB) WcSetInsensitive(this))
MakeButton(*saveFileAs,Save  Xet  Script  As...,WcCreateRootCB(filenameTBL) WcSetInsensitive(this))

MakeButton(*config,Set System Parameters,XetAction(configENV)  WcSetInsensitive(this))
MakeButton(*reinitialize,Re-Initialize Everything,XetAction(ReInitialize))
MakeButton(*recapture,Re-Capture Root Window,XetAction(reCaptureRootWindow))
MakeButton(*cleaninfotxt,Clean Info Text Window,XetAction(cleaninfotxt))
MakeButton(*dumpinfotxt,Dump Info Text To File,XetAction(dumpinfotxt))
MakeButton(*quit,Quit,WcManageCB(*exitDialog))

*exitDialog.wcConstructor:	XmCreateQuestionDialog
*exitDialog*fontList:           -*-lucida-bold-r-normal-*-12-*-75-75-*-*-*-*
*exitDialog.wcManaged:		False
*exitDialog.messageString:	Do you really want to exit?
*exitDialog.okCallback:		WcExit(1)

*File.subMenuId:	        ^*fileMenu

!------------------------build pulldown----------------------------
*menuBar.buildMenu.wcCreate:    XmCreatePulldownMenu
*buildMenu.wcChildren:	        importClip,string,shape, \
				sep1,sep1, snapShot


MakeButton(*importClip,Import  Clips,WcCreateRootCB(importTBL) \
                                     WcSetInsensitive(this))
MakeButton(*string,Build  Text,WcCreateRootCB(textTBL) WcSetInsensitive(this))
MakeButton(*shape,Build  Clip  Shape  Mask,WcCreateRootCB(shapeTBL) WcSetInsensitive(this))
MakeButton(*snapShot,Snap  Shot  Region,WcCreateRootCB(snapshotTBL) WcSetInsensitive(this))

MakeButton(*bground2,Edit  Background  Image,XetAction(edit background))

*Build.subMenuId:	         ^*buildMenu

!-----------------------------play menu pulldown----------------------------
*menuBar.playMenu.wcCreate:       XmCreatePulldownMenu
*playMenu.wcChildren:             scheduler, animationSetup

MakeButton(*scheduler,Animation Objects,WcSetInsensitive(this) WcCreateRootCB(schedulerTBL))  
MakeButton(*animationSetup,Animation  Setup,WcSetInsensitive(this) WcCreateRootCB(clipSetupTBL))    

*Play.subMenuId:	           ^*playMenu

!-----------------------------color menu pulldown----------------------------

*menuBar.colorMenu.wcCreate:       XmCreatePulldownMenu
*colorMenu.wcChildren:	           colorSelPanel,  \
                                   colorLoad, colorSave, colorFree

MakeButton(*colorSelPanel,View  Current  Color  Map,WcCreateRootCB(colorSelTBL) WcSetInsensitive(this))
MakeButton(*colorLoad,Load  Color  Map (ppm/ascii),WcCreateRootCB(LoadcmapFSB) WcSetInsensitive(this) )
MakeButton(*colorSave,Save  Current  Color  Map  As...,WcCreateRootCB(cmapfilenameTBL) WcSetInsensitive(this))
MakeButton(*colorFree,Free Cells  In  Current  Color  Map,XetAction(colorFreeCells))

*Color.subMenuId:	         ^*colorMenu

!-----------------------------misc menu pulldown----------------------------

*menuBar.miscMenu.wcCreate:       XmCreatePulldownMenu
*miscMenu.wcPopups:               gridsizeMenu
*miscMenu.wcChildren:	          spooler,    \
                                  defLocus,   \
                                  configClips,\
				  sep1,sep1,bground1,   \
	                          forge,      \
                                  sep1,sep1,  \
				  freezeLogo, unfreezeLogo, \
                                  sep1,sep1,grid

MakeButton(*forge,Set Fractal Background,WcCreateRootCB(forgeTBL) WcSetInsensitive(this))
MakeButton(*spooler,Display  Spooler  Queue,WcCreateRootCB(spoolerTBL) WcSetInsensitive(this))
MakeButton(*freezeLogo,Freeze Logo Animation, XetAction(freezeLogo))
MakeButton(*unfreezeLogo,Unfreeze Logo Animation, XetAction(unfreezeLogo))
MakeButton(*defLocus,Define Locus,WcCreateRootCB(locusTBL) WcSetInsensitive(this))
MakeButton(*bground1,Set  Background  Image,WcCreateRootCB(bgroundTBL) WcSetInsensitive(this))
MakeButton(*configClips,List of  Clips,WcSetInsensitive(this) WcCreateRootCB(configClipsTBL))
MakeButton(*grid,Draw Grid, XetAction(drawGrid))
*grid.labelString:                Draw Grid
*grid.subMenuId:                 *gridsizeMenu


*Misc.subMenuId:	          ^*miscMenu

*gridsizeMenu.wcConstructor:	  XmCreatePulldownMenu
*gridsizeMenu.wcChildren:	  g5,g10,g20,g50,g100,g200

MakeGridButton(*g5,      5, XetAction(drawGrid5))
MakeGridButton(*g10,    10, XetAction(drawGrid10))
MakeGridButton(*g20,    20, XetAction(drawGrid20))
MakeGridButton(*g50,    50, XetAction(drawGrid50))
MakeGridButton(*g100,  100, XetAction(drawGrid100))
MakeGridButton(*g200,  200, XetAction(drawGrid200))

!-----------------------help menu pulldown----------------------------------
*menuBar.helpMenu.wcCreate:         XmCreatePulldownMenu
*helpMenu.wcChildren:	            overView,GeneralHelp, \
                                    FileHelp,BuildHelp,PlayHelp, \
                                    ColorHelp, MiscHelp, xetSyntaxHelp, \
                                    DemoHelp

MakeButton(*overView,	   Overview, XetAction(xetHelpOverview))
MakeButton(*GeneralHelp,   General,  XetAction(xetHelpGeneral))
MakeButton(*FileHelp,	   File,     XetAction(xetHelpFile))
MakeButton(*BuildHelp,	   Build,    XetAction(xetHelpBuild))
MakeButton(*PlayHelp,	   Play,     XetAction(xetHelpPlay))
MakeButton(*ColorHelp,	   Color,    XetAction(xetHelpColor))
MakeButton(*MiscHelp,	   Misc,     XetAction(xetHelpMisc))
MakeButton(*xetSyntaxHelp, Xet File Syntax,    XetAction(xetHelpSyntax))
MakeButton(*DemoHelp,      How To Run Demo,    XetAction(xetHelpDemo))

*overView.alignment:       ALIGNMENT_CENTER
*GeneralHelp.alignment:    ALIGNMENT_CENTER
*FileHelp.alignment:       ALIGNMENT_CENTER
*BuildHelp.alignment:      ALIGNMENT_CENTER
*PlayHelp.alignment:       ALIGNMENT_CENTER
*ColorHelp.alignment:      ALIGNMENT_CENTER
*MiscHelp.alignment:       ALIGNMENT_CENTER
*xetSyntaxHelp.alignment:  ALIGNMENT_CENTER
*DemoHelp.alignment:       ALIGNMENT_CENTER

*Help.subMenuId:	   ^*helpMenu

!!*workAreaTBL.layout:		\
!!				xetStatistic       0 0   0 0    ; \
!!                                xetLogo1           1 0   3 0  HW; \
!!                                drawingWhere       4 0   0 0    ; \
!!                                drawingArea        0 1   5 100  ; \
!!                                infoTable          0 101 5 6

!#################################################################
!                    WorkAreaTBL
!#################################################################

*workAreaTBL.wcCreate:	        XmpTable
*workAreaTBL.wcChildren:	logoBar, drawingAreaTBL,  infoTable
*workAreaTBL.layout:		\
                                logoBar            0 0 Ht; \
                                drawingAreaTBL     0 1   ; \
                                infoTable          0 2 Hb

*workAreaTBL.marginHeight:      4
*workAreaTBL.marginWidth:       0
*workAreaTBL.rowSpacing:        2
*workAreaTBL.columnSpacing:     0

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*logoBar.wcCreate:	        XmpTable
*logoBar.wcChildren:	        xetLogo1, drawingWhere,	xetStatistic
*logoBar.layout:		\
				xetStatistic       0 0     H   ; \
                                xetLogo1           1 0     HW  ; \
                                drawingWhere       2 0     H   
!!*logoBar.borderWidth:         2
*logoBar.marginHeight:        2
*logoBar.marginWidth:         4
*logoBar.rowSpacing:          0

*xetLogo1.wcCreate:	        XmBulletinBoard
*xetLogo1.wcChildren:           xetLogo
*xetLogo1.layout:               0 0 WH
*xetLogo1.borderWidth:          0
*xetLogo1.marginWidth:          0
*xetLogo1.marginHeight:         0
*xetLogo1.bottomShadowColor:    XET_BLACK
*xetLogo1.topShadowColor:       XET_GRAY50
*xetLogo1.shadowThickness:      4

*xetLogo.wcCreate:	        XmDrawingArea
*xetLogo.x:                     4
*xetLogo.y:                     4
*xetLogo.borderWidth:           0
*xetLogo.height:                40
*xetLogo.width:                 300


MakeLB2(drawingWhere,(720 x 500)\n(0000,0000))
*drawingWhere.alignment:  ALIGNMENT_END
*drawingWhere.borderWidth:           0

MakeLB2(xetStatistic, \ Spooler     :  0 jobs  \n Clip Pool   :  0 clips \n Scheduler :  0/0 objects)
*xetStatistic.marginTop:        0
*xetStatistic.marginBottom:     0
*xetStatistic.borderWidth:           0

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*drawingAreaTBL.wcCreate:	   XmpTable
*drawingAreaTBL.wcChildren:        drawingArea
!!*drawingAreaTBL.layout:            0 0 
*drawingAreaTBL.borderWidth:       2
*drawingAreaTBL.borderColor:       XET_GRAY80
*drawingAreaTBL.marginHeight:      2
*drawingAreaTBL.marginWidth:       2

*drawingArea.wcCreate:	        XmDrawingArea
*drawingArea.borderWidth:       0
*drawingArea.borderColor:       XET_FIREBRICK3
*drawingArea.marginHeight:      0
*drawingArea.marginWidth:       0
*drawingArea.background:        XET_WHITE
*drawingArea.width:             720
*drawingArea.height:            500
*drawingArea.shadowThickness:   0
*drawingArea.wcPopups:          drawingAreaMenu


!! For some reason the following key bindings doesn't work properly
!! <KeyPress>u and <KeyPress>f don't work, but <Btn3Down> works,
!! I guess it is because  the drawingarea widget can not get keyboard focus,
!! therefore both 'f' and 'u' can not be delivered to the drawingarea widget.
!! I tried to moved the following translations to the XET widget and
!! it causes  XmpPopup(*drawingAreaMenu) never show up and x server hangs.
!! if you can fix this problem please let me know.
!!                                         Ko-Haw Nieh 11/17/1992

*drawingArea.translations:      #override \n \
                                <KeyPress>u: unfreezeMotion()  \n \
                                <KeyPress>f: freezeMotion()    \n \
                                <Btn3Down>: XmpPopup(*drawingAreaMenu) \n  


*infoTable.wcCreate:	        XmpTable
*infoTable.wcChildren:          infoTXT
*infoTable.layout:              infoTXT 0 0 HW
*infoTable.borderWidth:         1
*infoTable.marginWidth:         4
*infoTable.marginHeight:        4

MakeTextWidget(*infoTXT)
*infoTXT.editable:              TRUE
*infoTXT.rows:                   3

!#################################################################
!                   separators
!#################################################################

*sep1.wcConstructor:	XmCreateSeparator
*sep1.separatorType:	XmShadow_Etched_In
*sep2.wcConstructor:	XmCreateSeparator
*sep2.separatorType:	XmDOUBLE_DASHED_LINE


!####################################################

*drawingAreaMenu.wcConstructor:	XmCreatePopupMenu
*drawingAreaMenu.wcChildren:     pastePoints,repaint,clear, destroy

MakePushButton(pastePoints, Paste  Point,      XetAction(pastePoints))
MakePushButton(repaint, Repaint Drawing Area , XetAction(rePaintBackground))
MakePushButton(clear,   Clear Drawing Area ,   XetAction(clearDrawingArea))
MakePushButton(destroy, Destroy Drawing Area,  XetAction(destroyBackground))



