//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#include <X11/Wc/COPY>
#include "WCLiptr.h"
#include <osfcn.h>
#include <libc.h>
#include <X11/Xmu/Editres.h>

// All Wcl applications should provide at least these Wcl options:

static XrmOptionDescRec options[] = {
  WCL_XRM_OPTIONS
};
  
void WCLInterpreter::RegisterExternalWidgets ()
{
}

WCLInterpreter::WCLInterpreter(char *resName,int argc, char* argv[] )
{  
  appShell = XtInitialize ( 
	         argv[0], resName,	        // application name & class 
	         options, XtNumber(options),	// descr of cmd line options 
	         &argc, argv 
                 );
  app = XtWidgetToApplicationContext(appShell);
  // register the event handler to work with editres
  XtAddEventHandler(appShell, (EventMask) 0, True, 
		    (XtEventHandler) _XEditResCheckMessages, 
		    NULL);

  //Register all application specific callbacks and widget classes 
  RegisterExternalWidgets ();
  
  //  -- Register all Motif classes and constructors 
  XmpRegisterAll ( app );
  
  // register actions and callbacks
  
}

void WCLInterpreter::CreateAll(){
  //  -- Create widget tree below toplevel shell using Xrm database 
  if(WcWidgetCreation ( appShell ))
    exit(1);
  RegisterCallbacks();
  RegisterActions();
  XtRealizeWidget ( appShell );
}

void WCLInterpreter::Realize()
{
  XtRealizeWidget ( appShell );
}

Widget WCLInterpreter::nameToWidget(char *s){
  
  return (WcFullNameToWidget(appShell,s));
}

void WCLInterpreter::run()
{
  XtAppMainLoop(app);
}  
XtIntervalId  WCLInterpreter::registerXtAddTimeOut(unsigned long interval,
						   XtTimerCallbackProc proc,
						   XtPointer ptr)
{
  return XtAppAddTimeOut(app,interval,proc,ptr);
}

XtInputId WCLInterpreter::registerXtAddInput(int fp, 
					     XtInputCallbackProc proc,
					     XtPointer xp)
{
  return XtAppAddInput(app,fp,(XtPointer) XtInputReadMask ,proc,xp);
  
}

void WCLInterpreter::removeXtAddInput(XtInputId id){
  XtRemoveInput(id);
}
void WCLInterpreter::flush() {
  XFlush(XtDisplay(appShell));
}
