//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef CLIPSTABLE_H
#define CLIPSTABLE_H

#include <X11/Intrinsic.h>
#include <stdio.h>
#include "clip.h"
#include "hash.h"

class ClipsTable : public Hash {
protected:
  int     size;
  int     current;
  int     dup_index;
public:
  ClipsTable(int size = 20);
  ~ClipsTable();
  Clip	      *clone(char *);
  Clip	      *dup(char *);
  Clip	      *findClip(char *name);
  char	      *concateAllNames();
  int	       Howmany();
  int	       Size();
  int	       deleteClip(char *name);
  int	       deleteClipMask(char *name);
  void	       addClip(char *name,Clip *c);
  void	       buildClipsXmList(Widget w);
  void	       clearEverything();
  void	       renameKey(char *Old, char *New);
  void	       writeOut(FILE *fp);
};

#endif
