//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.


// The entire file will be re-written in the next release.
//      Ko-Haw Nieh December, 1992


#ifndef COLOR_H
#define COLOR_H

#include <X11/Intrinsic.h>
#include "colorHist.h"

enum CmapStatus {DEFAULT_E, PRIVATE_E, };

class Color {
protected:
  Display       *Dpy;
  Widget         defaultShell;
  Colormap       effectiveCmap;
  Colormap       defaultCmap;
  Colormap       privateCmap;
  ColorHist     *colorHist; 
  XColor        *reservedColors; 
  int            NoOfReservedColors;
  unsigned long  availableCells[256];
  int            NoOfAvailableCells;
  unsigned long  CellsCanBeFreed[256];
  int            maxval;
  CmapStatus     status;
  int            loadedCmap;  // == 1 indicates it is a loaded cmap and
                              // all cells can not be freed
public:
  Color(Display *D, Widget w);
  ~Color();
  CmapStatus	getCmapStatus();
  Colormap	getcmap();
  int		howMany()        { return colorHist->howMany();}
  int		registerNewColor(unsigned char, unsigned char, unsigned char);
  int           allocateNamedColor(char *);
  unsigned long allocateColor(XColor *colr);
  unsigned long findPixval(unsigned char, unsigned char, unsigned char);
  void          allocateAllAvailableCells();
  void		Initialize();
  void		buildPrivateCmap();
  void		fitIntoDefaultColormap();
  void		freeCmap();
  void          cleanCellsCanBeFreedArray();
  void          insertAMayBeFreedCells(unsigned long);
  void          locateReservedColors();
  void		loadcmap(FILE *s);
  void		setCmapStatus(CmapStatus);
  void		setMaxval(int m);
  void		setWindowColormap(Widget);
  void		writeCurrentCmap(char *s, int);
  void		writeCurrentCmapInASCII(char *s);
  void		writeCurrentCmapInPPm(char *s);
};

#endif
