//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef GLOBAL_H
#define GLOBAL_H

const int  MAJORVERSION  = 1;
const int  MINORVERSION  = 0;

extern char *CURRENT_DIRECTORY;
extern char *DEFAULT_BACKGROUND_FILE;
extern char *EFFECTIVE_DIRECTORY;
extern char *MESSAGE_WINDOW;
extern char *PRIVATE_COLORMAP;
extern char *XET_CURRENT_COLOR_MAP_FILE;
extern char *XET_DEFAULT_COLOR_MAP;
extern char *XET_DEFAULT_COLOR_MAP_FILE;
extern char *XET_ROOT_DIRECTORY;
extern char *XET_WORKING_DIRECTORY;

extern int   DEFAULT_MAX_LOCUS_POINTS;
extern int   MAX_SLOTS_IN_CLIP_TABLE;
extern int   MAX_SLOTS_IN_LOCUS_TABLE;
extern int   MAX_SLOTS_IN_SCHEDULER;
extern int   MIN_HASH_TABLE_SIZE;
extern int   SNAPSHOT_BLINKING_COUNT;
extern int   XET_OVERRIDE_FLAG;

extern char *CLIP_FORMAT;
extern char *CLIP_FORMAT_SCAN;
extern char *CLIP_FORMAT_SCAN_NAME;
extern char *LOCUS_FORMAT;
extern char *LOCUS_FORMAT_SCAN;
extern char *LOCUS_FORMAT_SCAN_NAME;
extern char *MOVIE_FORMAT;
extern char *MOVIE_FORMAT_SCAN;
extern char *SCHEDULER_FORMAT;
extern char *SCHEDULER_FORMAT_SCAN;
extern char *SCHEDULER_FORMAT_SCAN_NAME;
extern char *SPOOLER_FORMAT;
extern char *SPOOLER_FORMAT_SCAN;

// following are reserved colors for Xet
#define XET_FIREBRICK3  "firebrick3"
#define XET_NAVY        "navy"
#define XET_GRAY80      "gray80"
#define XET_GRAY50      "gray50"
#define XET_SKYBLUE4    "skyblue4"
#define XET_DEEPSKYBLUE "deepskyblue"
#define XET_WHEAT3      "wheat3"
#define XET_GOLDENROD   "goldenrod"
#define XET_WHITE       "white"
#define XET_BLACK       "black"
#define XET_TAN         "tan"


#define ALLOC_STRCPY(from,to)   {if(from) \
                                     delete from; \
				 if(to) { \
                                   from = new char[strlen(to)+1]; \
                                   strcpy(from,to); \
				 }else   \
				   from = to; }

#define STRCPY(from,to)     { from = new char[strlen(to)+1]; strcpy(from,to);}


enum Dir {FORWARD_E, BACKWARD_E,};

#endif
