//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef LOCUS_H
#define LOCUS_H

#include <stdio.h>

struct LocusPoint {
  int x;
  int y;
};

class Locus {
protected:
  char       *name;
  int         allocatedSize;
  int         size;
  int         current;
  LocusPoint *points;
  int         incr;
  int         RefCounter;
public:
  Locus(int size = 1000);
  Locus(Locus &);
  ~Locus();
  LocusPoint *getPoint(int which);
  char       *getName();
  int         addPoints(int x,int y);
  int         getRefCounter();
  int         getSize();
  int         load(char *filename);
  int         writeOut(char *);
  void        decrRefCounter();
  void        depositPoints(int size,LocusPoint *);
  void        endOfAddingPoints();
  void        incrRefCounter();
  void        initialize();
  void        setIncr(int);
  void        setName(char *);
  void        unique(int);
  void        writeOut(FILE *);
};

#endif
