//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef OUTPUT_WINDOW_H
#define OUTPUT_WINDOW_H

#include <X11/Intrinsic.h>

class OutputWindow {
public:
  Display        *Dpy;
  Widget          da_area;   // == NULL means root window
  Window          window;
  XImage         *backgroundImage;
  unsigned int    da_width;
  unsigned int    da_height;
  OutputWindow(Widget da);
  OutputWindow(Widget da,XImage *);
  OutputWindow(Display *);
  ~OutputWindow();
  void updateGeometryAndImage();
  void destroyBackground();
  void clearDrawingArea();
  void reCaptureRootWindow();
  void setImage(Pixmap pix);
  void putImage(GC gc);
};

#endif
