//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef PROC_MGR_H
#define PROC_MGR_H

#include "procEntry.h"

enum SpoolerStatus {SUSPEND_E, RESUME_E,};

class ProcSpooler {
protected:
  int            sizeOfQueue;
  ProcEntry     *procEntryQueue;     //linked list waiting for forking
  ProcEntry     *currentProcEntry;   // current running 
  SpoolerStatus  spoolerStatus;
public: 
  ProcSpooler();
  ~ProcSpooler();
  ProcEntry	*getCurrentEntry();
  SpoolerStatus  getSpoolerStatus();
  int		 Howmany();
  int            haveYouSeenThisName(char *);
  void		 registerAProcEntry(char *cmd,char *mode,int); 
  void		 registerAProcEntry(char *cmd,char *mode, char *filename, 
				    char *clipName,int);
  void		 setSpoolerStatus(SpoolerStatus);
  void		 finishUpCurrent(int fd);
  void		 buildQueueXmList(Widget);
  void		 startNextOne();
  void		 execCurrent();
  void		 move(int slot, int dir);
  void		 moveUp(int slot);
  void		 moveDown(int slot);
  void		 Delete(int slot);
  void		 DeleteAll();
};
#endif

