//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef RUN_MOVIE_H
#define RUN_MOVIE_H

#include <X11/Intrinsic.h>
#include "run_base.h"
#include "config.h"


class RunMovie : public RunBase {
friend class Xet;
protected:
  RunBase	*movie;
  RunBase	*tail;
  RunBase	*current;
  Dir		 dir;  
public:
  RunMovie(Display *d,OutputWindow *w);
  ~RunMovie();
  RunBase       *Copy();
  RunBase       *getAnObject(int i);
  unsigned long  getCurrentInterval();
  int            howmanyObjects();
  int            nextMove();
  void		 reset();
  void		 reverse();
  void		 reverseDeep();
  void           setOutputWindow(OutputWindow *);
  void		 addRunObject(RunBase *);
  void		 BuildMovieXmList(Widget w);
  void		 moveUp(int);
  void		 moveDown(int);
  void		 moveToFirst(int);
  void		 moveToLast(int);
  void		 exchange(int);
  void		 Delete(int);
  void           writeToDisk(FILE *);
};

#endif
